> For the complete documentation index, see [llms.txt](https://docs.nosto.com/magento-2/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nosto.com/magento-2/guides/overriding-or-extending-functionalities/overriding-product-data/customising-categories.md).

# Customising Categories

If your store uses a customized logic for handling product's categories you might need to amend categories in Nosto module as well . Start by reading [how to extend Nosto module](/magento-2/guides/overriding-or-extending-functionalities.md) and [how to alter Nosto product data](/magento-2/guides/overriding-or-extending-functionalities/overriding-product-data.md).

If overriding the product data directly does not seem the best option for you, you can create a service class and make use of Dependency Injection pattern.

Create a new class which will implement `CategoryServiceInterface`. Override the required functions and afterwards replace `CategoryServiceInterface` with `MyCategoryServive` in the DI `etc/di.xml`

File `app/code/My/Nosto/Model/Service/MyCategoryServive.php`

```php
<?php

namespace My\Nosto\Model\Service;

use Nosto\Tagging\Model\Service\Product\Category\CategoryServiceInterface;
use Magento\Catalog\Model\Category;
use Magento\Catalog\Model\Product;
use Magento\Store\Api\Data\StoreInterface;

class MyCategoryServive implements CategoryServiceInterface
{   

    /**
     * Method used to return a single category string for given category object
     * @param Category $category
     * @param StoreInterface $store
     * @return null|string
     */
    public function getCategory(Category $category, StoreInterface $store) {
        //ToDo Implement logic    
    }   

    /**
     * Method used to return list of strings representing categories for a given product 
     * @param Product $product
     * @param StoreInterface $store
     * @return array
     */
    public function getCategories(Product $product, StoreInterface $store) {

    }   
}
```

File `app/code/My/Nosto/etc/di.xml`

```markup
<config xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:noNamespaceSchemaLocation="urn:magento:framework:ObjectManager/etc/config.xsd">
    <preference for="Nosto\Tagging\Model\Service\Product\Category\CategoryServiceInterface" type="My\Nosto\Model\Service\MyCategoryServive"/>
</config>
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nosto.com/magento-2/guides/overriding-or-extending-functionalities/overriding-product-data/customising-categories.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
